Kubernetes Apply Deployment

  • PATCH
  • /workspaces
  • /:workspace
  • /projects
  • /:project_name
  • /pipelines
  • /:pipeline_id
  • /actions
  • /:action_id

Update Kubernetes Apply Deployment action configuration

Warning
You can't change the type of an existing action. To change the type, remove the action and add it again.

Request

REQUIRED SCOPES
EXECUTION_MANAGE
URL PARAMETERS
workspacerequiredstring
The human-readable ID of the workspace

Example: "my-company"

project_namerequiredstring
The human-readable ID of the project

Example: "my-project"

pipeline_idrequiredinteger
The ID of the pipeline

Example: 123

action_idrequiredinteger
The ID of the action

Example: 456

POST PARAMETERS
typerequiredstring enum
The type of the action
Allowed enum:
KUBERNETES_APPLY
urlread-onlystring
API endpoint to GET this object
html_urlread-onlystring
Web URL to view this object in Buddy.works
after_action_idinteger
The numerical ID of the action, after which this action should be added
namerequiredstring
The name of the action
trigger_timestring enum
Specifies when the action should be executed
Allowed enum:
ON_EVERY_EXECUTION,
ON_SUCCESS,
ON_FAILURE,
ON_BACK_TO_SUCCESS,
ON_WARNING,
ON_WAIT_FOR_APPROVE,
ON_TERMINATE
trigger_conditionsTriggerConditionView[]
The list of trigger conditions to meet so that the action can be triggered
run_nextstring enum
Defines whether the action should run in parallel with the next one
Allowed enum:
WAIT_ON_SUCCESS,
IN_SOFT_PARALLEL,
IN_HARD_PARALLEL
run_only_on_first_failureboolean
Defines whether the action should be executed on each failure. Restricted to and required if the trigger_time is ON_FAILURE
variablesEnvironmentVariableView[]
The list of variables you can use the action
disabledboolean
When set to true the action is disabled. By default it is set to false
timeoutinteger
The timeout in seconds
ignore_errorsboolean
If set to true the execution will proceed, mark action as a warning and jump to the next action. Doesn't apply to deployment actions
retry_countinteger
Number of retries if the action fails
retry_intervalinteger
Delay time between auto retries in seconds
loopstring[]
The list of commands that will be executed in a loop
current_revisionstring
The git revision of the last successful run of the action
permissionsPermissionsView
Access permissions configuration
config_pathstring
The path to the Kubernetes configuration file
kubectl_versionstring
The version of kubectl to use
setup_commandsstring[]
The command that will be executed only on the first run
targetsTargetView[]
The list of Kubernetes cluster targets
namespacerequiredstring
The Kubernetes namespace
contentstring
The content of the Kubernetes configuration
execute_every_commandboolean
If set to true all commands will be executed regardless of the result of the previous command
record_argstring enum
Record current kubectl command in the resource annotation. If set to false, do not record the command. If set to true, record the command. If not set, default to updating the existing annotation value only if one already exists
Allowed enum:
TRUE,
FALSE,
NOT_SET
save_config_argboolean
If true, the configuration of current object will be saved in its annotation. Otherwise, the annotation will be unchanged. This flag is useful when you want to perform kubectl apply on this object in the future.
overwrite_argboolean
Automatically resolve conflicts between the modified and live configuration by using values from the modified configuration.
cascade_argboolean
Only relevant during a prune or a force apply. If true, cascade the deletion of the resources managed by pruned or deleted resources (e.g. Pods created by a ReplicationController).
cascadestring enum
Defines cascade deletion behavior for resources
Allowed enum:
BACKGROUND,
ORPHAN,
FOREGROUND
all_argboolean
Defines whether to select all the specified resources.
grace_period_arginteger
Only relevant during a prune or a force apply. Period of time in seconds given to pruned or deleted resources to terminate gracefully. Ignored if negative.
prune_argboolean
Automatically delete resource objects that do not appear in the configs and are created by either apply or create –save-config. Should be used with either -l or –all.
prune_whitelist_argstring
Overwrite the default whitelist with <group/version/kind> for –prune.
force_argboolean
Delete and re-create the specified resource, when PATCH encounters conflict and has retried for 5 times.
validateboolean
Validates the configuration before applying

Response

RESPONSE BODY
typestring enum
The type of the action
Allowed enum:
KUBERNETES_APPLY
urlread-onlystring
API endpoint to GET this object
html_urlread-onlystring
Web URL to view this object in Buddy.works
idinteger
The ID of the action
namestring
The name of the action
current_revisionstring
The git revision of the last successful run of the action
trigger_timestring enum
Specifies when the action should be executed
Allowed enum:
ON_EVERY_EXECUTION,
ON_SUCCESS,
ON_FAILURE,
ON_BACK_TO_SUCCESS,
ON_WARNING,
ON_WAIT_FOR_APPROVE,
ON_TERMINATE
trigger_conditionsTriggerConditionView[]
The list of trigger conditions to meet so that the action can be triggered
run_nextstring enum
Defines whether the action should run in parallel with the next one
Allowed enum:
WAIT_ON_SUCCESS,
IN_SOFT_PARALLEL,
IN_HARD_PARALLEL
run_only_on_first_failureboolean
Defines whether the action should be executed on each failure. Restricted to and required if the trigger_time is ON_FAILURE
variablesEnvironmentVariableView[]
The list of variables you can use the action
disabledboolean
When set to true the action is disabled. By default it is set to false
timeoutinteger
The timeout in seconds
ignore_errorsboolean
If set to true the execution will proceed, mark action as a warning and jump to the next action. Doesn't apply to deployment actions
retry_countinteger
Number of retries if the action fails
retry_intervalinteger
Delay time between auto retries in seconds
last_execution_statusstring enum
The status of the last run of the action
Allowed enum:
INPROGRESS,
ENQUEUED,
TERMINATED,
SUCCESSFUL,
FAILED,
INITIAL,
NOT_EXECUTED,
SKIPPED,
TERMINATING,
WAITING_FOR_APPLY,
WAITING_FOR_VARIABLES,
WAITING_FOR_SETTABLE_VARIABLES,
WAITING_FOR_VT_SESSION
pipelineShortPipelineView
Short representation of a pipeline
permissionsPermissionsView
Access permissions configuration
loopstring[]
The list of commands that will be executed in a loop
config_pathstring
The path to the Kubernetes configuration file
kubectl_versionstring
The version of kubectl to use
setup_commandsstring[]
The command that will be executed only on the first run
targetsTargetView[]
The list of Kubernetes cluster targets
namespacestring
The Kubernetes namespace
contentstring
The content of the Kubernetes configuration
execute_every_commandboolean
If set to true all commands will be executed regardless of the result of the previous command
record_argstring enum
Record current kubectl command in the resource annotation. If set to false, do not record the command. If set to true, record the command. If not set, default to updating the existing annotation value only if one already exists
Allowed enum:
TRUE,
FALSE,
NOT_SET
save_config_argboolean
If true, the configuration of current object will be saved in its annotation. Otherwise, the annotation will be unchanged. This flag is useful when you want to perform kubectl apply on this object in the future.
overwrite_argboolean
Automatically resolve conflicts between the modified and live configuration by using values from the modified configuration.
cascade_argboolean
Only relevant during a prune or a force apply. If true, cascade the deletion of the resources managed by pruned or deleted resources (e.g. Pods created by a ReplicationController).
cascadestring enum
Defines cascade deletion behavior for resources
Allowed enum:
BACKGROUND,
ORPHAN,
FOREGROUND
all_argboolean
Defines whether to select all the specified resources.
grace_period_arginteger
Only relevant during a prune or a force apply. Period of time in seconds given to pruned or deleted resources to terminate gracefully. Ignored if negative.
prune_argboolean
Automatically delete resource objects that do not appear in the configs and are created by either apply or create –save-config. Should be used with either -l or –all.
prune_whitelist_argstring
Overwrite the default whitelist with <group/version/kind> for –prune.
force_argboolean
Delete and re-create the specified resource, when PATCH encounters conflict and has retried for 5 times.
validateboolean
Validates the configuration before applying

Last modified on Feb 18, 2026

Request example

curl -X PATCH "https://api.buddy.works/workspaces/:workspace/projects/:project_name/pipelines/:pipeline_id/actions/:action_id" \ -H "Authorization: Bearer <YOUR-TOKEN>" \ -H "Content-Type: application/json" \ -d '{ "name": "Apply deployment", "type": "KUBERNETES_APPLY", "trigger_time": "ON_EVERY_EXECUTION", "targets": [ { "zone": "europe-west1-c", "project_id": "tokyo-house-138923", "identifier": "my_target_id", "name": "my-target", "integration": "5ddb7c180fb38be67bd78a88a", "type": "GKE", "scope": "ACTION", "tags": [ "olive", "orange", "rabsperry" ], "cluster": "cluster-1" } ], "config_path": "config.yaml", "record_arg": "NOT_SET", "save_config_arg": false, "force_arg": false, "overwrite_arg": false, "cascade_arg": false, "all_arg": true, "grace_period_arg": 0, "prune_arg": true, "prune_whitelist_arg": "", "timeout": "600" }'
STATUS
200 OK